﻿var app_version = parseInt(app.version);
var mainUI = CheckUI (this);

MakePrimitive (app_version);

function MakePrimitive(){
    if(app_version >= 9){
        if(!(mainUI instanceof Panel)){
            mainUI.center();
            mainUI.show();
            }
        
        /***********************************************************************************************/
        //      アイテムの登録
        /***********************************************************************************************/
        if(mainUI != null){
            var primList = ["Random Position", "Wiggly Position", "Grid", "Cylinder" , "Echospace"];

            var sep_makePrimitive = mainUI.add('panel', [20, 10, 20 + 215, 10 + 200], "Make Primitive");
            var sep_duplicate = mainUI.add('panel', [20, 215, 20 + 215, 215 + 55], "Duplicate Layer");

            var panel_create = sep_makePrimitive.add('panel', [10, 10, 10 + 190, 10 + 80], "Create");
            panel_create.add('statictext', [10, 15, 10 + 90, 15 + 10], "Time Offset[sec] : ");
            var offsetTime = panel_create.add('edittext', [100, 13, 100 + 80, 13 + 20], "");
            var dropdown_primitive = panel_create.add('dropdownlist', [10, 40, 10 + 110, 40 + 20], primList);
            var apply_primitive = panel_create.add('button', [125, 40, 125 + 50, 40 + 20], "Apply");

            var panel_remove = sep_makePrimitive.add('panel', [10, 95, 10 + 190, 95 + 80], "Remove");
            var dropdown_remove = panel_remove.add('dropdownlist', [23, 15, 23 + 80, 15 + 20], ["NULL"]);
            var refresh_remove = panel_remove.add('button', [107, 15, 107 + 55, 15 + 20], "Refresh");
            var remove_primitive = panel_remove.add('button', [43, 40, 43 + 100, 40 + 20], "Remove");

            var nums_duplicate = sep_duplicate.add('edittext', [10, 15, 10 + 90, 15 + 20], "10");
            var apply_duplicate = sep_duplicate.add('button', [106, 15, 106 + 94, 15 + 20], "Duplicate");

            dropdown_primitive.items[0].selected = true;
            dropdown_remove.items[0].selected = true;

            var mp_text = "<SCRIPT_MAKEPRIMITIVE>_";

            var createType = "Random Position";
            var array_remove = new Array();
            var counter_remove = 0;

            dropdown_primitive.onChange = function(){ createType = dropdown_primitive.selection.text; }
            GetCreateType = function(){ return createType; }

            apply_primitive.onClick = function(){
                var createType = GetCreateType ();
                var checkLayers = CheckLayers ();
                
                CreatePrimitive (createType, checkLayers);
                }
            
            refresh_remove.onClick = function(){
                RemoveListRefresh ();
                }
            
            remove_primitive.onClick = function(){
                var targetComps = new Array();
                var prj_items = app.project.numItems;
                var remove_primitive = RemovePrimitiveID ();
                var remove_set = remove_primitive[0];
                var remove_index = remove_primitive[1];
                var primitive_nums = 0;
                
                if(remove_set != "NULL"){
                    for(i = 1; i <= prj_items; i++){
                        if(app.project.item(i) instanceof CompItem){
                            targetComps.push(app.project.item(i));
                            }
                        
                        else if(app.project.item(i) instanceof FootageItem){
                            if(app.project.item(i).name.indexOf(mp_text + "Repeater - " + remove_set) != "-1"){
                                var repeater_source = app.project.item(i);
                                }
                            
                            else if(app.project.item(i).name.indexOf(mp_text + "Instance - " + remove_set) != "-1"){
                                var instance_source = app.project.item(i)
                                }
                            }
                        }
                    }
                
                PrimitiveRemove (targetComps, remove_set, remove_index, repeater_source, instance_source)
                }
        
            apply_duplicate.onClick = function(){
                selLayer = app.project.activeItem.selectedLayers;
                DuplicateLayer (selLayer)
                }
            
            /*---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
            //      プリミティブセットを作成する
            /*---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
            function CreatePrimitive(createType, checkLayers){
                var layerText = "Layers - ";
                if(checkLayers instanceof Array){
                    var createtype = GetCreateType ();
                    var array_target = checkLayers[0];
                    var target_first = checkLayers[1];
                    var target_end = checkLayers[2];
                    
                    var myComp = array_target[0].containingComp;
            
                    for(i = 0; i < array_target.length; i++){
                        if(i != 0)
                        array_target[i].shy = true;
                        array_target[i].threeDLayer = true;
                        }
				
                    if(array_target != null && array_target.length > 0){
                        var addRepeater = AddRepeater (array_target, createType, target_first)
                        var repeaterNull = addRepeater[0];
                        var propertyName = addRepeater[1];
                        var primID = addRepeater[2];
                            
                        var instanceArray = AddInstances (array_target, repeaterNull, primID, target_end);
                        
                        repeaterNull.selected = true;
                        
                        //適用可能レイヤーのトランスフォーム、マテリアルを全て一元管理
                        LayerPropsWiring (array_target, primID);
                        
                        for(j = 0; j < array_target.length; j++)
                        array_target[j].comment = mp_text + layerText + primID;
                        
                        array_remove[counter_remove] = primID.toString();
                        counter_remove += 1;
                            
                            /*---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
                            //      適用可能レイヤーへのエクスプレッションの追加
                            /*---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
                            switch(createType){
                                case "Random Position" :
                                for(i = 0; i < instanceArray.length; i++){
                                    instanceArray[i].property("ADBE Transform Group").position.expression = "src = thisComp.layer(\"" + repeaterNull.name + "\");\nxOffset = src.effect(\"" + propertyName[0] + "\")(1) / 2;    //X位置\nyOffset = src.effect(\"" + propertyName[1] + "\")(1) / 2;    //Y位置\nzOffset = src.effect(\"" + propertyName[2] + "\")(1) / 2;    //Z位置\nseed = src.effect(\"" + propertyName[6] + "\")(1);   //ランダムシード\n\nseedRandom(seed, true);\nrnd = random([-xOffset, - yOffset, -zOffset], [xOffset, yOffset, zOffset]);";
                                    instanceArray[i].property("ADBE Transform Group").property("ADBE Rotate X").expression = "src = thisComp.layer(\"" + repeaterNull.name + "\");\nrot = src.effect(\"" + propertyName[3] + "\")(1) / 2;   //X回転\nseed = src.effect(\"" + propertyName[6] + "\")(1);   //ランダムシード\nseedRandom(seed,true)\n\nrandom(-rot, rot)";
                                    instanceArray[i].property("ADBE Transform Group").property("ADBE Rotate Y").expression = "src = thisComp.layer(\"" + repeaterNull.name + "\");\nrot = src.effect(\"" + propertyName[4] + "\")(1) / 2;   //Y回転\nseed = src.effect(\"" + propertyName[6] + "\")(1);   //ランダムシード\nseedRandom(seed,true)\n\nrandom(-rot, rot)";
                                    instanceArray[i].property("ADBE Transform Group").property("ADBE Rotate Z").expression = "src = thisComp.layer(\"" + repeaterNull.name + "\");\nrot = src.effect(\"" + propertyName[5] + "\")(1) / 2;   //Z回転\nseed = src.effect(\"" + propertyName[6] + "\")(1);   //ランダムシード\nseedRandom(seed,true)\n\nrandom(-rot, rot)";
                                    }
                                break;
                                
                                case "Wiggly Position" :
                                for(i = 0; i < instanceArray.length; i++){
                                    instanceArray[i].property("ADBE Transform Group").property("ADBE Position").expression = "src = thisComp.layer(\"" + repeaterNull.name + "\");\nxAmp = src.effect(\"" + propertyName[1] + "\")(1);\nyAmp = src.effect(\"" + propertyName[2] + "\")(1);\nzAmp = src.effect(\"" + propertyName[3] + "\")(1);\nfrequence = src.effect(\"" + propertyName[0] + "\")(1);\noctFrec = src.effect(\"" + propertyName[8] + "\")(1);\noct = src.effect(\"" + propertyName[7] + "\")(1);\nseed = src.effect(\"" + propertyName[9] + "\")(1);\n\nseedRandom(seed + " + i + ")\nxWiggle = wiggle(frequence, xAmp, octFrec, oct)[0];\nyWiggle = wiggle(frequence, yAmp, octFrec, oct)[1];\nzWiggle = wiggle(frequence, zAmp, octFrec, oct)[2];\n\n[xWiggle, yWiggle, zWiggle];";
                                    instanceArray[i].property("ADBE Transform Group").property("ADBE Rotate X").expression = "src = thisComp.layer(\"" + repeaterNull.name + "\");\nrot = src.effect(\"" + propertyName[4] + "\")(1);\nfrequence = src.effect(\"" + propertyName[0] + "\")(1);\nseed = src.effect(\"" + propertyName[9] + "\")(1);\nseedRandom(seed + " + i + ");\n\nwiggle(frequence, rot);";
                                    instanceArray[i].property("ADBE Transform Group").property("ADBE Rotate Y").expression = "src = thisComp.layer(\"" + repeaterNull.name + "\");\nrot = src.effect(\"" + propertyName[5] + "\")(1);\nfrequence = src.effect(\"" + propertyName[0] + "\")(1);\nseed = src.effect(\"" + propertyName[9] + "\")(1);\nseedRandom(seed + " + i + ");\n\nwiggle(frequence, rot);";
                                    instanceArray[i].property("ADBE Transform Group").property("ADBE Rotate Z").expression = "src = thisComp.layer(\"" + repeaterNull.name + "\");\nrot = src.effect(\"" + propertyName[6] + "\")(1);\nfrequence = src.effect(\"" + propertyName[0] + "\")(1);\nseed = src.effect(\"" + propertyName[9] + "\")(1);\nseedRandom(seed + " + i + ");\n\nwiggle(frequence, rot);";                    
                                    }
                                break;
                                
                                case "Grid" :
                                if(array_target.length >= 2){
                                    for(i = 0; i < array_target.length; i++){
                                        instanceArray[i].property("ADBE Transform Group").property("ADBE Position").expression = "src = thisComp.layer(\"" + repeaterNull.name + "\");\nlayerID = " + (i + 1) + ";      //レイヤーごとのID\nallLayers = " + array_target.length + ";        //レイヤー総数\ngridRows = Math.floor(src.effect(\"" + propertyName[0] + "\")(1));      //グリッドの行数\ngridSize = src.effect(\"" + propertyName[1] + "\")(1)      //グリッドのXY軸オフセット\ngridZOffset = src.effect(\"" + propertyName[5] + "\")(1);        //グリッドのZ軸オフセット\ncolumnBased = src.effect(\"" + propertyName[2] + "\")(1);     //列ベースのZ軸オフセット\ncheckerBased = src.effect(\"" + propertyName[3] + "\")(1);      //チェッカーベースのZ軸オフセット\nrandomBased = src.effect(\"" + propertyName[4] + "\")(1);       //ランダムベースのZ軸オフセット\nseed = src.effect(\"" + propertyName[6] + "\")(1);     //ランダムシード\n\nif(gridRows < 2) { gridRows = 2; } else if(gridRows >= allLayers) { gridRows = allLayers; }       //側面数の0除算回避・レイヤー総数以上の値を受け付けない\n\n//列にかかる係数を設定\ncolumnMultiply = Math.floor(layerID / gridRows)\nif(layerID == gridRows) columnMultiply = 0;\nelse if((layerID >= gridRows) && ((layerID % gridRows) == 0)) columnMultiply = Math.floor(layerID / gridRows) - 1;\n\n//行にかかる係数を設定\nrowsMultiply = Math.floor(layerID % gridRows) - 1;\nif((layerID % gridRows) == 0){ rowsMultiply = gridRows - 1; }\n\ngridXPos = gridSize[0] * columnMultiply;\ngridYPos = gridSize[1] * rowsMultiply;\ngridZPos = gridZOffset * rowsMultiply;\nif(columnBased == true){ gridZPos = gridZOffset * columnMultiply; }\nif((checkerBased == true) && (layerID % 2 == 0)){ gridZPos = gridZOffset * -1; }\nelse if((checkerBased == true) && (layerID % 2 != 0)){ gridZPos = gridZOffset; }\nif(randomBased == true){seedRandom(seed, true); gridZPos = random(-gridZOffset, gridZOffset);  }\n[gridXPos, gridYPos, gridZPos];";
                                        }
                                    repeaterNull.property("ADBE Effect Parade").property(2).selected = true;
                                    }
                                else{
                                    for(i = 0; i < instanceArray.length; i++)
                                    instanceArray[i].remove();
                                    repeaterNull.remove();
                                    alert("2枚以上のレイヤー選択してください");
                                    }
                                break;
                                
                                case "Cylinder" :
                                if(array_target.length >= 2){
                                    for(i = 0; i < array_target.length; i++){
                                        instanceArray[i].property("ADBE Transform Group").property("ADBE Position").expression = "src = thisComp.layer(\"" + repeaterNull.name + "\");\nlayerID = " + (i + 1) + ";       //レイヤーごとのID\nallLayers = " + array_target.length + ";     //レイヤー総数\ncylinderEdges = Math.floor(src.effect(\"" + propertyName[0] + "\")(1));       //シリンダーの側面数\ncylinderRadius = src.effect(\"" + propertyName[1] + "\")(1);       //シリンダーの半径\ncylinderHeight = -src.effect(\"" + propertyName[2] + "\")(1);        //シリンダーの高さ\ncylinderTaper = src.effect(\"" + propertyName[3] + "\")(1);		//シリンダーのテーパー\ncylinderCompletion = -src.effect(\"" + propertyName[4] + "\")(1);      //シリンダーの完成度\nrotInverse = src.effect(\"" + propertyName[5] + "\")(1);        //2の倍数の段の逆回転\ncylinderScrew = src.effect(\"" + propertyName[6] + "\")(1);     //段数により回転角に差をつける\ncylinderRotation = src.effect(\"" + propertyName[7] + "\")(1);      //シリンダーの回転\nif(cylinderEdges < 2) { cylinderEdges = 2; } else if(cylinderEdges >= allLayers) { cylinderEdges = allLayers; }       //側面数の0除算回避・レイヤー総数以上の値を受け付けない\n\nstepsMultiply = Math.floor(layerID / cylinderEdges);        //係数\n//高さにかかる係数を設定\nif(layerID == cylinderEdges) stepsMultiply = 0;\nelse if((layerID >= cylinderEdges) && ((layerID % cylinderEdges) == 0)) stepsMultiply = Math.floor(layerID / cylinderEdges) - 1;\n\n//側面にかかる係数を設定\nedgesMultiply = Math.floor(layerID % cylinderEdges) - 1;\nif((layerID % cylinderEdges) == 0){ edgesMultiply = cylinderEdges - 1; }\n\n//" + propertyName[5] + "がtrueの時、偶数段は逆回転する\nif((rotInverse == true) && ((stepsMultiply % 2) != 0)) cylinderRotation *= -rotInverse;\n\n//" + propertyName[6] + "がtrueの時、段数により回転角に差をつける\nif(cylinderScrew == true) cylinderRotation *= stepsMultiply + 1;\n\ndegrees = 360 / cylinderEdges;\nangle = degreesToRadians(cylinderRotation + (layerID * degrees) + (cylinderCompletion * edgesMultiply));\n\nradiansX = Math.sin(angle) * (cylinderRadius + (-cylinderTaper  * stepsMultiply));\nradiansZ = Math.cos(angle) * (cylinderRadius + (-cylinderTaper * stepsMultiply));\n\n[radiansX , cylinderHeight * stepsMultiply, radiansZ];";
                                        instanceArray[i].property("ADBE Transform Group").property("ADBE Rotate Y").expression = "src = thisComp.layer(\"" + repeaterNull.name + "\");\nlayerID = " + (i + 1) + ";       //レイヤーごとのID\nallLayers = " +array_target.length + ";     //レイヤー総数\ncylinderEdges = Math.floor(src.effect(\"" + propertyName[0] + "\")(1));       //シリンダーの側面数\ncylinderCompletion = -src.effect(\"" + propertyName[4] + "\")(1);      //シリンダーの完成度\nrotInverse = src.effect(\"" + propertyName[5] + "\")(1);        //2の倍数の段の逆回転\ncylinderScrew = src.effect(\"" + propertyName[6] + "\")(1);     //段数により回転角に差をつける\ncylinderRotation = src.effect(\"" + propertyName[7] + "\")(1);      //シリンダーの回転\nif(cylinderEdges < 2) { cylinderEdges = 2; } else if(cylinderEdges > allLayers) { cylinderEdges= allLayers; }       //側面数の0除算回避・レイヤー総数以上の値を受け付けない\n\nstepsMultiply = Math.floor(layerID / cylinderEdges);       //係数\n//高さにかかる係数を設定\nif(layerID == cylinderEdges) stepsMultiply = 0;\nelse if((layerID >= cylinderEdges) && ((layerID % cylinderEdges) == 0)) stepsMultiply = Math.floor(layerID / cylinderEdges) - 1;\n\n//側面にかかる係数を設定\nedgesMultiply = Math.floor(layerID % cylinderEdges);\nif((layerID % cylinderEdges) == 0){ edgesMultiply = cylinderEdges; }\n\n//" + propertyName[5] + "がtrueの時、偶数段は逆回転する\nif((rotInverse == true) && ((stepsMultiply % 2) != 0)) cylinderRotation *= -rotInverse;\n\n//" + propertyName[6] + "がtrueの時、段数により回転角に差をつける\nif(cylinderScrew == true) cylinderRotation *= stepsMultiply + 1;\n\nrot = ((360 / cylinderEdges) * edgesMultiply + (cylinderCompletion * (edgesMultiply - 1)));\n\nrot + cylinderRotation;\n\nif(src.effect(\"" + repeaterNull.property("ADBE Effect Parade").property(repeaterNull.property("ADBE Effect Parade").numProperties - 1).name + "\")(1) == true)\ntransform.yRotation;";
                                        }
                                    }
                                
                                else{
                                    for(i = 0; i < instanceArray.length; i++)
                                    instanceArray[i].remove();
                                    repeaterNull.remove();
                                    alert("2枚以上のレイヤーを選択してください");
                                    }
                                break;
                                
                                case "Echospace" :
                                for(i = 0; i < array_target.length; i++){
                                    if(i != 0){
                                        instanceArray[i].property("ADBE Transform Group").property("ADBE Position").expression = "src = thisComp.layer(\"" + repeaterNull.name + "\");\nrDelay = time - " + i + " * src.effect(\"" + propertyName[12] + "\")(1);\nxRnd = src.effect(\"" + propertyName[8] + "\")(1);\nyRnd = src.effect(\"" + propertyName[9] + "\")(1);\nzRnd = src.effect(\"" + propertyName[10] + "\")(1);\nseedRnd = src.effect(\"" + propertyName[11] + "\")(1);\n\nxOffset = src.effect(\"" + propertyName[0] + "\")(1).valueAtTime(rDelay) * " + i + ";\nyOffset = src.effect(\"" + propertyName[1] + "\")(1).valueAtTime(rDelay) * " + i + ";\nzOffset = src.effect(\"" + propertyName[2] + "\")(1).valueAtTime(rDelay) * " + i + ";\n\nseedRandom(seedRnd, true);\nofsRnd = random([-xRnd / 2, -yRnd / 2, -zRnd / 2], [xRnd / 2, yRnd / 2, zRnd / 2]);\n\n[xOffset + ofsRnd[0], yOffset + ofsRnd[1], zOffset + ofsRnd[2]];"
                                        instanceArray[i].property("ADBE Transform Group").property("ADBE Rotate X").expression = "src = thisComp.layer(\"" + repeaterNull.name + "\")\nrDelay = time - " + i + " * src.effect(\"" + propertyName[12] + "\")(1);\n\nrepeaterRot = src.effect(\"" + propertyName[3] + "\")(1).valueAtTime(rDelay) * " + i + ";";
                                        instanceArray[i].property("ADBE Transform Group").property("ADBE Rotate Y").expression = "src = thisComp.layer(\"" + repeaterNull.name + "\")\nrDelay = time - " + i + " * src.effect(\"" + propertyName[12] + "\")(1);\n\nrepeaterRot = src.effect(\"" + propertyName[4] + "\")(1).valueAtTime(rDelay) * " + i + ";";
                                        instanceArray[i].property("ADBE Transform Group").property("ADBE Rotate Z").expression = "src = thisComp.layer(\"" + repeaterNull.name + "\")\nrDelay = time - " + i + " * src.effect(\"" + propertyName[12] + "\")(1);\n\nrepeaterRot = src.effect(\"" + propertyName[5] + "\")(1).valueAtTime(rDelay) * " + i + ";";
                                        array_target[i].property("ADBE Transform Group").property("ADBE Position").expression = "tSrc = thisComp.layer(\"" + array_target[0].name + "\");\nrSrc = thisComp.layer(\"" + repeaterNull.name + "\");\ntDelay = time - " + i + " * rSrc.effect(\"" + propertyName[13] + "\")(1);\n\ntSrc.position.valueAtTime(tDelay);";
                                        if(array_target[i].property("ADBE Transform Group").property("ADBE Orientation").canSetExpression)
                                        array_target[i].property("ADBE Transform Group").property("ADBE Orientation").expression = "tSrc = thisComp.layer(\"" + array_target[0].name + "\");\nrSrc = thisComp.layer(\"" + repeaterNull.name + "\");\ntDelay = time - " + i + " * rSrc.effect(\"" + propertyName[13] + "\")(1);\n\ntSrc.orientation.valueAtTime(tDelay);";
                                        if(array_target[i].property("ADBE Transform Group").property("ADBE Rotate X").canSetExpression)
                                        array_target[i].property("ADBE Transform Group").property("ADBE Rotate X").expression = "tSrc = thisComp.layer(\"" + array_target[0].name + "\");\nrSrc = thisComp.layer(\"" + repeaterNull.name + "\");\ntDelay = time - " + i + " * rSrc.effect(\"" + propertyName[13] + "\")(1);\n\ntSrc.transform.xRotation.valueAtTime(tDelay);";
                                        if(array_target[i].property("ADBE Transform Group").property("ADBE Rotate Y").canSetExpression)
                                        array_target[i].property("ADBE Transform Group").property("ADBE Rotate Y").expression = "tSrc = thisComp.layer(\"" + array_target[0].name + "\");\nrSrc = thisComp.layer(\"" + repeaterNull.name + "\");\ntDelay = time - " + i + " * rSrc.effect(\"" + propertyName[13] + "\")(1);\n\ntSrc.transform.yRotation.valueAtTime(tDelay);";
                                        if(array_target[i].property("ADBE Transform Group").property("ADBE Rotate Z").canSetExpression)
                                        array_target[i].property("ADBE Transform Group").property("ADBE Rotate Z").expression = "tSrc = thisComp.layer(\"" + array_target[0].name + "\");\nrSrc = thisComp.layer(\"" + repeaterNull.name + "\");\ntDelay = time - " + i + " * rSrc.effect(\"" + propertyName[13] + "\")(1);\n\ntSrc.transform.zRotation.valueAtTime(tDelay);";
                                        if((array_target[i] instanceof AVLayer) || (array_target[i] instanceof TextLayer) || (array_target[i] instanceof  ShapeLayer)){
                                            array_target[i].property("ADBE Transform Group").property("ADBE Anchor Point").expression = "tSrc = thisComp.layer(\"" + array_target[0].name + "\");\nrSrc = thisComp.layer(\"" + repeaterNull.name + "\");\ntDelay = time - " + i + " * rSrc.effect(\"" + propertyName[13] + "\")(1);\n\ntSrc.anchorPoint.valueAtTime(tDelay);";
                                            array_target[i].property("ADBE Transform Group").property("ADBE Scale").expression = "tSrc = thisComp.layer(\"" + array_target[0].name + "\");\nrSrc = thisComp.layer(\"" + repeaterNull.name + "\");\nrDelay = time - " + i + " * rSrc.effect(\"" + propertyName[12] + "\")(1);\ntDelay = time - " + i + " * rSrc.effect(\"" + propertyName[13] + "\")(1);\n\ntSrc.scale.valueAtTime(tDelay) + rSrc.effect(\"" + propertyName[6] + "\")(1).valueAtTime(rDelay) * " + i + " * [1, 1, 1];";
                                            array_target[i].property("ADBE Transform Group").property("ADBE Opacity").expression = "tSrc = thisComp.layer(\"" + array_target[0].name + "\");\nrSrc = thisComp.layer(\"" + repeaterNull.name + "\");\nrDelay = time - " + i + " * rSrc.effect(\"" + propertyName[12] + "\")(1);\ntDelay = time - " + i + " * rSrc.effect(\"" + propertyName[13] + "\")(1);\n\ntSrc.opacity.valueAtTime(tDelay) + rSrc.effect(\"" + propertyName[7] + "\")(1).valueAtTime(rDelay) * " + i + ";";
                                            }
                                        else
                                        if(array_target[i].property("ADBE Transform Group").property("ADBE Anchor Point").canSetExpression)
                                        array_target[i].property("ADBE Transform Group").property("ADBE Anchor Point").expression = "tSrc = thisComp.layer(\"" + array_target[0].name + "\");\nrSrc = thisComp.layer(\"" + repeaterNull.name + "\");\ntDelay = time - " + i + " * rSrc.effect(\"" + propertyName[13] + "\")(1);\n\ntSrc.pointOfInterest.valueAtTime(tDelay);";
                                        }
                                    }
                                break;
                                }
                            var timeOffset = CheckText(offsetTime.text)
                            for(i = 0; i < array_target.length; i++){
                                if(timeOffset != null && timeOffset != 0)
                                array_target[i].inPoint = timeOffset * i;
                                array_target[i].outPoint = (array_target[i].inPoint + timeOffset * i) + array_target[i].outPoint;
                                instanceArray[i].property("ADBE Transform Group").property("ADBE Orientation").expression = "src = thisComp.layer(\"" + repeaterNull.name + "\");\nlookEn = src.effect(\"" + repeaterNull.property("ADBE Effect Parade").property(repeaterNull.property("ADBE Effect Parade").numProperties - 1).name + "\")(1);\nlookLayer = src.effect(\"" + repeaterNull.property("ADBE Effect Parade").property(repeaterNull.property("ADBE Effect Parade").numProperties).name + "\")(1);\n\nif(lookEn == true){\nif(lookLayer.hasParent == true) lookAt(position, lookLayer.position + lookLayer.parent.position);\nelse if((lookLayer.hasParent != true) && (thisLayer.parent != lookLayer)) lookAt(position + [" + (myComp.width / 2) + ", " + (myComp.height / 2) + ", 0]  , lookLayer.position)\nelse if((lookLayer.hasParent != true) && (thisLayer.parent == lookLayer)) lookAt(position + lookLayer.position, lookLayer.position)} else thisLayer.orientation;";
                                }
                            }
                        } else alert("適用可能なレイヤーが選択されていません");
                    }
                }
            
            /*---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
            //      プリミティブのリピーターとなるヌルオブジェクトを作成する
            /*---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
            function AddRepeater(targetLayers, createType, targetFirst){
                var myComp = targetLayers[0].containingComp;
                var rpatText = "Repeater - ";
                
                var null_repeater = myComp.layers.addNull();
                null_repeater.threeDLayer = true;
			
                var ID = null_repeater.source.id;
                null_repeater.source.name = mp_text + rpatText + ID;
                null_repeater.comment = mp_text + rpatText + ID;
			
                var rp_staticName = " Repeater [" + ID + "]";
                var rp_exControlName;
                
                switch(createType){
                    case "Random Position" :
                    null_repeater.name = "RP" + rp_staticName;
                    rp_exControlName = new Array("X Random Position", "Y Random Position", "Z Random Position", "X Random Rotation", "Y Random Rotation", "Z Random Rotation", "Random Seed");
                    
                    e1 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
                    e1.name = rp_exControlName[0];
                    e2 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
                    e2.name = rp_exControlName[1];
                    e3 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
                    e3.name = rp_exControlName[2];
                    e4 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Angle Control");
                    e4.name = rp_exControlName[3];
                    e5 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Angle Control");
                    e5.name = rp_exControlName[4];
                    e6 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Angle Control");
                    e6.name = rp_exControlName[5];
                    e7 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
                    e7.name = rp_exControlName[6];
                    break;
                    
                    case "Wiggly Position" :
                    null_repeater.name = "WP" + rp_staticName;
                    rp_exControlName = new Array("Wiggle [sec]", "X Wiggly Position", "Y Wiggly Position", "Z Wiggly Position", "X Wiggly Rotation", "Y Wiggly Rotation", "Z Wiggly Rotation", "Noise [sec]", "Noise Wiggle", "Random Seed");
                    
                    e1 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
                    e1.name = rp_exControlName[0];
                    e1(1).setValue(1);
                    e2 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
                    e2.name = rp_exControlName[1];
                    e3 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
                    e3.name = rp_exControlName[2];
                    e4 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
                    e4.name = rp_exControlName[3];
                    e5 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Angle Control");
                    e5.name = rp_exControlName[4];
                    e6 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Angle Control");
                    e6.name = rp_exControlName[5];
                    e7 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Angle Control");
                    e7.name = rp_exControlName[6];
                    e8 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
                    e8.name = rp_exControlName[7];
                    e8(1).setValue(1);
                    e9 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
                    e9.name = rp_exControlName[8];
                    e9(1).setValue(0.5);
                    e10 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
                    e10.name = rp_exControlName[9];
                    break;
                    
                    case "Grid" :
                    null_repeater.name = "GR" + rp_staticName;
                    rp_exControlName = new Array("Grid Rows","Grid Size", "Column based Z Offset", "Checker based Z Offset", "Random Z Offset", "Z Offset", "Random Seed");
                    
                    e1 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
                    e1.name = rp_exControlName[0];
                    e2 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Point Control");
                    e2.name = rp_exControlName[1];
                    e3 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Checkbox Control");
                    e3.name = rp_exControlName[2];
                    e4 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Checkbox Control");
                    e4.name = rp_exControlName[3];
                    e5 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Checkbox Control");
                    e5.name = rp_exControlName[4];
                    e6 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
                    e6.name = rp_exControlName[5];
                    e7 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
                    e7.name = rp_exControlName[6];
                    break;
                    
                    case "Cylinder" :
                    null_repeater.name = "CY" + rp_staticName;
                    rp_exControlName = new Array("Cylinder Edges", "Cylinder Radius", "Cylinder Height", "Cylinder Taper", "Completion", "2n Inverse Rotation", "Screw", "Cylinder Rotation");
                    
                    e1 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
                    e1.name = rp_exControlName[0];
                    e1(1).setValue(4);
                    e2 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
                    e2.name = rp_exControlName[1];
                    e3 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
                    e3.name = rp_exControlName[2];
                    e4 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
                    e4.name = rp_exControlName[3];
                    e5 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
                    e5.name = rp_exControlName[4];
                    e6 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Checkbox Control");
                    e6.name = rp_exControlName[5];
                    e7 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Checkbox Control");
                    e7.name = rp_exControlName[6];
                    e8 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Angle Control");
                    e8.name = rp_exControlName[7];
                    break;
                    
                    case "Echospace" :
                    null_repeater.name = "EC" + rp_staticName;
                    rp_exControlName = new Array("X Offset", "Y Offset", "Z Offset", "X Rotate", "Y Rotate", "Z Rotate", "Scale", "Opacity", "X Offset Random", "Y Offset Random", "Z Offset Random", "Random Seed", "Repeater Delay [sec]", "Transform Delay [sec]");
                    
                    e1 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
                    e1.name = rp_exControlName[0];
                    e2 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
                    e2.name = rp_exControlName[1];
                    e3 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
                    e3.name = rp_exControlName[2];
                    e4 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
                    e4.name = rp_exControlName[3];
                    e5 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
                    e5.name = rp_exControlName[4];
                    e6 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
                    e6.name = rp_exControlName[5];
                    e7 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
                    e7.name = rp_exControlName[6];
                    e8 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
                    e8.name = rp_exControlName[7];
                    e9 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
                    e9.name = rp_exControlName[8];
                    e10 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
                    e10.name = rp_exControlName[9];
                    e11 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
                    e11.name = rp_exControlName[10];
                    e12 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
                    e12.name = rp_exControlName[11];
                    e13 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
                    e13.name = rp_exControlName[12];
                    e14 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
                    e14.name = rp_exControlName[13];
                    break;
                    }
                
                var rp_allAddEx1 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Checkbox Control");
                rp_allAddEx1.name = "Look At";
                var rp_allAddEx2 = null_repeater.property("ADBE Effect Parade").addProperty("ADBE Layer Control");
                rp_allAddEx2.name = "Look Layer";
                
                null_repeater.moveBefore(targetLayers[targetFirst]);
                
                var rp_exNums = null_repeater.property("ADBE Effect Parade").numProperties;
                
                for(i = 1; i <= rp_exNums; i++){
                    null_repeater.property("ADBE Effect Parade").property(i).enabled = false;
                    }
                
                return [null_repeater, rp_exControlName, ID];
                }
            
            /*---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
            //      選択されたレイヤーとリンクするヌルオブジェクトを追加する
            /*---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
            function AddInstances(targetLayers, primRepeater, primID, targetEnd){
                var add_to_comp = targetLayers[0].containingComp;        //インスタンスの追加先となるコンポジション
                var array_instance = new Array();       //作成された全インスタンスを収納する配列
                var instText = "Instance - "
                
                var null_instance = add_to_comp.layers.addNull();
                null_instance.enabled = false;
                null_instance.shy = true;
                null_instance.threeDLayer = true;
                null_instance.source.name = mp_text + instText + primID;
                null_instance.comment = mp_text + instText + primID;
                
                //渡されたされたレイヤーの枚数分インスタンスとなるヌルオブジェクトを作成する
                for(i = 0; i < targetLayers.length; i++){
                    var mainInstance = null_instance.duplicate();
                    mainInstance.name = "Instance [" + primID + " - 0" + (i + 1) + "]";
                    mainInstance.threeDLayer = true;
                    targetLayers[i].parent = mainInstance;
                    mainInstance.parent = primRepeater;
                    array_instance[i] = mainInstance;
                    }
                
                for(j = 0; j < targetLayers.length; j++){
                    array_instance[array_instance.length - (1 + j)].moveAfter(targetLayers[targetEnd]);
                    }
                
                //初めに作成したヌルは必要ないので削除
                null_instance.remove();
                
                return array_instance;
                }
            
            /*---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
            //      渡されたレイヤーの配列中、2番目以降のレイヤーのトランスフォーム系統、マテリアル系統のプロパティを1番目のレイヤーの同プロパティとリンクする
            /*---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
            function LayerPropsWiring(targetArray, primID){
                var tPropsMatchName;
                var mPropsMatchName;
                
                for(var i = 0; i < targetArray.length; i++){
                    targetArray[i].name += " - [" + primID + "]";
                    if(i == 0) targetArray[0].name += "_Parent";
                    
                    for(var j = 1; j < targetArray.length; j++){
                        var counter = 1;
                        var visiblity_props = VisiblityProperties (targetArray[j])
                        var vis_tProps = visiblity_props[0];
                        var vis_mProps = visiblity_props[1];
                        
                        for(var k = 1; k <= vis_tProps.length; k++){
                            if(counter == vis_tProps[k - 1]){
                                tPropMatchName = targetArray[j].property("ADBE Transform Group").property(counter).matchName;
                                switch(tPropMatchName){
                                    case "ADBE Anchor Point" :
                                    targetArray[j].property("ADBE Transform Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").transform.anchorPoint;";
                                    break;
                                    
                                    case "ADBE Position" :
                                    targetArray[j].property("ADBE Transform Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").transform.position;";
                                    break;
                                    
                                    case "ADBE Position_0" :
                                    if(targetArray[0].property("ADBE Transform Group").property("ADBE Position").canSetExpression) targetArray[j].property("ADBE Transform Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").transform.position[0];";
                                    else targetArray[j].property("ADBE Transform Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").transform.xPosition;";
                                    break;
                                    
                                    case "ADBE Position_1" :
                                    if(targetArray[0].property("ADBE Transform Group").property("ADBE Position").canSetExpression) targetArray[j].property("ADBE Transform Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").transform.position[1];";
                                    else targetArray[j].property("ADBE Transform Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").transform.yPosition;";
                                    break;
                                    
                                    case "ADBE Position_2" :
                                    if(targetArray[0].property("ADBE Transform Group").property("ADBE Position").canSetExpression) targetArray[j].property("ADBE Transform Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").transform.position[2];";
                                    else targetArray[j].property("ADBE Transform Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").transform.zPosition;";
                                    break;
                                    
                                    case "ADBE Scale" :
                                    targetArray[j].property("ADBE Transform Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").transform.scale;";
                                    break;
                                    
                                    case "ADBE Orientation" :
                                    targetArray[j].property("ADBE Transform Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").transform.orientation;";
                                    break;
                                    
                                    case "ADBE Rotate X" :
                                    targetArray[j].property("ADBE Transform Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").transform.xRotation;";
                                    break;
                                    
                                    case "ADBE Rotate Y" :
                                    targetArray[j].property("ADBE Transform Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").transform.yRotation;";
                                    break;
                                    
                                    case "ADBE Rotate Z" :
                                    targetArray[j].property("ADBE Transform Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").transform.zRotation;";
                                    break;
                                    
                                    case "ADBE Opacity" :
                                    targetArray[j].property("ADBE Transform Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").transform.opacity;";
                                    break;
                                    }
                                }
                            
                            else{
                                counter += 1;
                                k -= 1;
                                }
                            }
                        
                        counter = 1;
                        
                        for(var l = 1; l <= vis_mProps.length; l++){
                            if(counter == vis_mProps[l - 1]){
                                if(targetArray[j] instanceof AVLayer || targetArray[j] instanceof TextLayer || targetArray[j] instanceof ShapeLayer){
                                    mPropMatchName = targetArray[j].property("ADBE Material Options Group").property(counter).matchName;
                                    switch(mPropMatchName){
                                        case "ADBE Light Transmission" :
                                        targetArray[j].property("ADBE Material Options Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").materialOption.lightTransmission;";
                                        break;
                                        
                                        case "ADBE Ambient Coefficient" :
                                        targetArray[j].property("ADBE Material Options Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").materialOption.ambient;";
                                        break;
                                        
                                        case "ADBE Diffuse Coefficient" :
                                        targetArray[j].property("ADBE Material Options Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").materialOption.diffuse;";
                                        break;
                                        
                                        case "ADBE Specular Coefficient" :
                                        targetArray[j].property("ADBE Material Options Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").materialOption.specular;";
                                        break;
                                        
                                        case "ADBE Shininess Coefficient" :
                                        targetArray[j].property("ADBE Material Options Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").materialOption.shininess;";
                                        break;
                                        
                                        case "ADBE Metal Coefficient" :
                                        targetArray[j].property("ADBE Material Options Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").materialOption.metal;";
                                        break;
                                        }
                                    }
                                
                                else if(targetArray[j] instanceof LightLayer){
                                    mPropsMatchName = targetArray[j].property("ADBE Light Options Group").property(counter).matchName;
                                    switch(mPropsMatchName){
                                        case "ADBE Light Intensity" :
                                        targetArray[j].property("ADBE Light Options Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").lightOption.intensity;";
                                        break;
                                        
                                        case "ADBE Light Color" :
                                        targetArray[j].property("ADBE Light Options Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").lightOption.color;";
                                        break;
                                        
                                        case "ADBE Light Cone Angle" :
                                        targetArray[j].property("ADBE Light Options Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").lightOption.coneAngle;";
                                        break;
                                        
                                        case "ADBE Light Cone Feather 2" :
                                        targetArray[j].property("ADBE Light Options Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").lightOption.coneFeather;";
                                        break;
                                        
                                        case "ADBE Light Falloff Type" :
                                        targetArray[j].property("ADBE Light Options Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").lightOption.falloff;";
                                        break;
                                        
                                        case "ADBE Light Falloff Start" :
                                        targetArray[j].property("ADBE Light Options Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").lightOption.radius;";
                                        break;
                                        
                                        case "ADBE Light Falloff Distance" :
                                        targetArray[j].property("ADBE Light Options Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").lightOption.falloffDistance;";
                                        break;
                                        
                                        case "ADBE Light Shadow Darkness" :
                                        targetArray[j].property("ADBE Light Options Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").lightOption.shadowDarkness;";
                                        break;
                                        
                                        case "ADBE Light Shadow Diffusion" :
                                        targetArray[j].property("ADBE Light Options Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").lightOption.shadowDiffusion;";
                                        break;
                                        }
                                    }
                                
                                else{
                                    mPropsMatchName = targetArray[j].property("ADBE Camera Options Group").property(counter).matchName;
                                    switch(mPropsMatchName){
                                        case "ADBE Camera Zoom" :
                                        targetArray[j].property("ADBE Camera Options Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").cameraOption.zoom;";
                                        break;
                                        
                                        case "ADBE Camera Depth of Field" :
                                        targetArray[j].property("ADBE Camera Options Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").cameraOption.depthOfField;";
                                        break;
                                        
                                        case "ADBE Camera Focus Distance" :
                                        targetArray[j].property("ADBE Camera Options Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").cameraOption.focusDistance;";
                                        break;
                                        
                                        case "ADBE Camera Aperture" :
                                        targetArray[j].property("ADBE Camera Options Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").cameraOption.aperture;";
                                        break;
                                        
                                        case "ADBE Camera Blur level" :
                                        targetArray[j].property("ADBE Camera Options Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").cameraOption.blurLevel;";
                                        break;
                                        
                                        case "ADBE Iris Shape" :
                                        targetArray[j].property("ADBE Camera Options Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").cameraOption.irisShape;";
                                        break;
                                        
                                        case "ADBE Camera Zoom" :
                                        targetArray[j].property("ADBE Camera Options Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").cameraOption.zoom;";
                                        break;
                                        
                                        case "ADBE Iris Rotation" :
                                        targetArray[j].property("ADBE Camera Options Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").cameraOption.irisRotation;";
                                        break;
                                        
                                        case "ADBE Iris Roudness" :
                                        targetArray[j].property("ADBE Camera Options Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").cameraOption.irisRoudness;";
                                        break;
                                        
                                        case "ADBE Iris Aspect Ratio" :
                                        targetArray[j].property("ADBE Camera Options Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").cameraOption.irisAspectRatio;";
                                        break;
                                    
                                        case "ADBE Iris Diffraction Fringe" :
                                        targetArray[j].property("ADBE Camera Options Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").cameraOption.irisDiffractionFringe;";
                                        break;
                                        
                                        case "ADBE Iris Highlight Gain" :
                                        targetArray[j].property("ADBE Camera Options Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").cameraOption.highlightGain;";
                                        break;
                                        
                                        case "ADBE Iris Highlight Threshold" :
                                        targetArray[j].property("ADBE Camera Options Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").cameraOption.highlightThreshold;";
                                        break;
                                        
                                        case "ADBE Iris Hightlight Saturation" :
                                        targetArray[j].property("ADBE Camera Options Group").property(counter).expression = "thisComp.layer(\"" + targetArray[0].name + "\").cameraOption.highlightSaturation;";
                                        break;
                                        }
                                    }
                                }
                            else{
                                counter += 1;
                                l -= 1;
                                }
                            }
                        }
                    }
                }
            
            /*---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
            //      選択されたレイヤーのトランスフォーム系統のプロパティとマテリアル系統のプロパティのうち、値のセットが可能なプロパティを抽出する
            //      抽出されたプロパティのインデックスをトランスフォーム用の配列、マテリアル用の配列に収納し返す
            /*---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
            function VisiblityProperties(targetLayer){
                var counter = 0;
                var visible_tProperties = new Array();
                var visible_mProperties = new Array();
                var err = new Error();
		
                var tNumProperties = targetLayer.property("ADBE Transform Group").numProperties;
                var mNumProperties;
                if(targetLayer instanceof AVLayer || targetLayer instanceof TextLayer || targetLayer instanceof ShapeLayer){ mNumProperties = targetLayer.property("ADBE Material Options Group").numProperties; }
                else if(targetLayer instanceof LightLayer){ mNumProperties = targetLayer.property("ADBE Light Options Group").numProperties; }
                else{ mNumProperties = targetLayer.property("ADBE Camera Options Group").numProperties; }
                
                for(i = 1; i <= tNumProperties; i++){
                    err = null;
                    err = targetLayer.property("ADBE Transform Group").property(i).canSetExpression;
                    if(err ){
                        visible_tProperties[counter] = i;
                        counter += 1;
                        }
                    }
                
                counter = 0;
                
                for(j = 1; j <= mNumProperties; j++){
                    err = null;
                    if(targetLayer instanceof AVLayer || targetLayer instanceof TextLayer || targetLayer instanceof ShapeLayer){
                        err = targetLayer.property("ADBE Material Options Group").property(j).canSetExpression;
                        if(err == true){
                            visible_mProperties[counter] = j;
                            counter += 1;
                            }
                        
                        if(j == mNumProperties)
                        counter = 0;
                        }
                    
                    else if(targetLayer instanceof LightLayer){
                        err = targetLayer.property("ADBE Light Options Group").property(j).canSetExpression;
                        if(err == true){
                            visible_mProperties[counter] = j;
                            counter += 1;
                            }
                        if(j == mNumProperties)
                        counter = 0;
                        }
                    
                    else{
                        err = targetLayer.property("ADBE Camera Options Group").property(j).canSetExpression;
                        if(err == true){
                            visible_mProperties[counter] = j;
                            counter += 1;
                            }
                        if(j == mNumProperties)
                        counter = 0;
                        }
                    }
                return [visible_tProperties, visible_mProperties];
                }
            
            /*---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
            //      プリミティブセットの削除を行う
            //      1つのセットの判別はレイヤーに登録されたコメントで行う
            /*---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
            function PrimitiveRemove(targetComps, remove_set, remove_index, repeater_source, instance_source){
                for(var i = 0; i < targetComps.length; i++){
                    for(var j = targetComps[i].numLayers; j >= 1; j--){
                        if(targetComps[i].layers[j].comment.indexOf(remove_set) != "-1"){
                            var array_r = targetComps[i].layers[j].comment.split(" - ");
                            switch(array_r[0] + remove_set){
                                case "<SCRIPT_MAKEPRIMITIVE>_Layers" + remove_set :
                                tNumProperties = targetComps[i].layers[j].property("ADBE Transform Group").numProperties;
                                if(targetComps[i].layers[j] instanceof AVLayer || targetComps[i].layers[j] instanceof TextLayer || targetComps[i].layers[j] instanceof ShapeLayer){
                                    mNumProperties = targetComps[i].layers[j].property("ADBE Material Options Group").numProperties;
                                    }
                                
                                else if(targetComps[i].layers[j] instanceof LightLayer){
                                    mNumProperties = targetComps[i].layers[j].property("ADBE Light Options Group").numProperties;
                                    }
                                
                                else{
                                    mNumProperties = targetComps[i].layers[j].property("ADBE Camera Options Group").numProperties;
                                    }
                            
                            for(var k = 1; k <= tNumProperties; k++){
                                if(targetComps[i].layers[j].property("ADBE Transform Group").property(k).expressionEnabled){
                                    targetComps[i].layers[j].property("ADBE Transform Group").property(k).expression ="";
                                    }
                                
                                var time_undoOffset = targetComps[i].layers[j].inPoint;
                                targetComps[i].layers[j].inPoint -= time_undoOffset * k;
                                targetComps[i].layers[j].outPoint = targetComps[i].duration;
                                
                                LayersReset (targetComps[i].layers[j])
                                }
                            
                            for(var l = 1; l <= mNumProperties; l++){
                                if(targetComps[i].layers[j] instanceof AVLayer || targetComps[i].layers[j] instanceof TextLayer || targetComps[i].layers[j] instanceof ShapeLayer){
                                    if(targetComps[i].layers[j].property("ADBE Material Options Group").property(l).expressionEnabled){
                                        targetComps[i].layers[j].property("ADBE Material Options Group").property(l).expression = "";
                                        }
                                    }
                                
                                else if(targetComps[i].layers[j] instanceof LightLayer){
                                    if(targetComps[i].layers[j].property("ADBE Light Options Group").property(l).expressionEnabled){
                                        targetComps[i].layers[j].property("ADBE Light Options Group").property(l).expression = "";
                                        }
                                    }
                                
                                else{
                                    if(targetComps[i].layers[j].property("ADBE Camera Options Group").property(l).expressionEnabled){
                                        targetComps[i].layers[j].property("ADBE Camera Options Group").property(l).expression = "";
                                        }
                                    }
                                }
                            
                            if(targetComps[i].layers[j].name.indexOf("Parent")){
                                var name_original = targetComps[i].layers[j].name.split(" - ");
                                targetComps[i].layers[j].name = name_original[0];
                                }
                            
                            targetComps[i].layers[j].comment = "";
                            targetComps[i].layers[j].shy = false;
                            targetComps[i].layers[j].threeDLayer = false;
                            break;
                            
                            case "<SCRIPT_MAKEPRIMITIVE>_Repeater" + remove_set :
                            targetComps[i].layers[j].remove();
                            break;
                            
                            case "<SCRIPT_MAKEPRIMITIVE>_Instance" + remove_set :
                            targetComps[i].layers[j].remove();
                            break;
                            }
                        }
                    }
                
                if(instance_source != null && repeater_source != null){
                    instance_source.remove();
                    repeater_source.remove();
                    }
                
                array_remove.splice(remove_index, 1);
                counter_remove -= 1;
                RemoveListRefresh ();
                }
            }
        
        /*---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
        //      渡されたレイヤーのトランスフォーム系統・マテリアル系統のプロパティをリセットする
        /*---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
        function LayersReset(reset_layer){
            if((reset_layer instanceof AVLayer && reset_layer.hasVideo) || reset_layer instanceof TextLayer || reset_layer instanceof ShapeLayer || reset_layer instanceof LightLayer || reset_layer instanceof CameraLayer){
                for(i = 1; i <= reset_layer.property("ADBE Transform Group").numProperties; i++){
                    if(reset_layer.property("ADBE Transform Group").property(i).canSetExpression){
                        switch(reset_layer.property("ADBE Transform Group").property(i).matchName){
                            case "ADBE Anchor Point" :
                            if((reset_layer instanceof AVLayer && reset_layer.hasVideo) || reset_layer instanceof TextLayer || reset_layer instanceof ShapeLayer || reset_layer instanceof LightLayer)
                            reset_layer.property("ADBE Transform Group").property(i).setValue([reset_layer.width / 2, reset_layer.height / 2, 0]);
                            
                            else
                            reset_layer.property("ADBE Transform Group").property(i).setValue([0, 0, 0]);
                            break;
                            
                            case "ADBE Position" :
                            reset_layer.property("ADBE Transform Group").property(i).setValue([0, 0, 0]);
                            break;
                            
                            case "ADBE Position_0" :
                            reset_layer.property("ADBE Transform Group").property(i).setValue(0);
                            break;
                            
                            case "ADBE position_1" :
                            reset_layer.property("ADBE Transform Group").property(i).setValue(0);
                            break;
                            
                            case "ADBE Position_2" :
                            reset_layer.property("ADBE Transform Group").property(i).setValue(0);
                            break;
                            
                            case "ADBE Scale" :
                            reset_layer.property("ADBE Transform Group").property(i).setValue([100, 100, 100,]);
                            break;
                            
                            case "ADBE Orientation" :
                            reset_layer.property("ADBE Transform Group").property(i).setValue([0, 0, 0]);
                            break;
                            
                            case "ADBE Rotate X" :
                            reset_layer.property("ADBE Transform Group").property(i).setValue(0);
                            break;
                            
                            case "ADBE Rotate Y" :
                            reset_layer.property("ADBE Transform Group").property(i).setValue(0);
                            break;
                            
                            case "ADBE Rotate Z" :
                            reset_layer.property("ADBE Transform Group").property(i).setValue(0);
                            break;
                            
                            case "ADBE Opacity" :
                            reset_layer.property("ADBE Transform Group").property(i).setValue(100);
                            break;
                            }
                        }
                    }
                
                if((reset_layer instanceof AVLayer && reset_layer.hasVideo) || reset_layer instanceof TextLayer || reset_layer instanceof ShapeLayer){
                    for(j = 1; j <= reset_layer.property("ADBE Material Options Group").numProperties; j++){
                        if(reset_layer.property("ADBE Material Options Group").property(j).canSetExpression){
                            switch(reset_layer.property("ADBE Material Options Group").property(j).matchName){
                                case "ADBE Light Transmission" :
                                reset_layer.property("ADBE Material Options Group").property(j).setValue(0);
                                break;
                                
                                case "ADBE Ambient Coefficient" :
                                reset_layer.property("ADBE Material Options Group").property(j).setValue(100);
                                break;
                                
                                case "ADBE Diffuse Coefficient" :
                                reset_layer.property("ADBE Material Options Group").property(j).setValue(50);
                                break;
                                
                                case "ADBE Specular Coefficient" :
                                reset_layer.property("ADBE Material Options Group").property(j).setValue(50);
                                break;
                                
                                case "ADBE Shininess Coefficient" :
                                reset_layer.property("ADBE Material Options Group").property(j).setValue(5);
                                break;
                                
                                case "ADBE Metal Coefficient" :
                                reset_layer.property("ADBE Material Options Group").property(j).setValue(100);
                                break;
                                }
                            }
                        }
                    }
                
                else if(reset_layer instanceof LightLayer){
                    for(k = 1; k <= reset_layer.property("ADBE Light Options Group").numProperties; k++){
                        if(reset_layer.property("ADBE Light Options Group").property(k).canSetExpression){
                            switch(reset_layer.property("ADBE Light Options Group").property(k).matchName){
                                case "ADBE Light Intensity" :
                                reset_layer.property("ADBE Light Options Group").property(k).setValue(100);
                                break;
                                
                                case "ADBE Light Cone Angle" :
                                reset_layer.property("ADBE Light Options Group").property(k).setValue(120);
                                break;
                                
                                case "ADBE Light Cone Feather" :
                                reset_layer.property("ADBE Light Options Group").property(k).setValue(100);
                                break;
                                
                                case "ADBE Light Falloff Start" :
                                reset_layer.property("ADBE Light Options Group").property(k).setValue(500);
                                break;
                                
                                case "ADBE Light Falloff Distance" :
                                reset_layer.property("ADBE Light Options Group").property(k).setValue(500);
                                break;
                                
                                case "ADBE Shadow Darkness" :
                                reset_layer.property("ADBE Light Options Group").property(k).setValue(100);
                                break;
                                
                                case "ADBE Light Shadow Difuse" :
                                reset_layer.property("ADBE Light Options Group").property(k).setValue(0);
                                }
                            }
                        }
                    }
                
                else{
                    for(l = 1; l <= reset_layer.property("ADBE Camera Options Group").numProperties; l++){
                        if(reset_layer.property("ADBE Camera Options Group").property(l).canSetExpression){
                            switch(reset_layer.property("ADBE Camera Options Group").property(l).matchName){
                                case "ADBE Camera Zoom" :
                                reset_layer.property("ADBE Camera Options Group").property(l).setValue(1244.4444);
                                break;
                                
                                case "ADBE Focus Distance" :
                                reset_layer.property("ADBE Camera Options Group").property(l).setValue(1244.4444);
                                break;
                                
                                case "ADBE Camera Aperture" :
                                reset_layer.property("ADBE Camera Options Group").property(l).setValue(17.7);
                                break;
                                
                                case "ADBE Camera Blur Level" :
                                reset_layer.property("ADBE Camera Options Group").property(l).setValue(100);
                                break;
                                
                                case "ADBE Iris Rotation" :
                                reset_layer.property("ADBE Camera Options Group").property(l).setValue(0);
                                break;
                                
                                case "ADBE Iris Roundness" :
                                reset_layer.property("ADBE Camera Options Group").property(l).setValue(0);
                                break;
                                
                                case "ADBE Iris Aspect Ratio" :
                                reset_layer.property("ADBE Camera Options Group").property(l).setValue(1);
                                break;
                                
                                case "ADBE Iris Diffraction Fringe" :
                                reset_layer.property("ADBE Camera Options Group").property(l).setValue(0);
                                break;
                                
                                case "ADBE Iris Highlight Gain" :
                                reset_layer.property("ADBE Camera Options Group").property(l).setValue(0);
                                break;
                                
                                case "ADBE Highlight Threshold" :
                                reset_layer.property("ADBE Camera Options Group").property(l).setValue(255);
                                break;
                                
                                case "ADBE Hightlight Saturation" :
                                reset_layer.property("ADBE Camera Options Group").property(l).setValue(0);
                                break;
                                }
                            }
                        }
                    }
                }
            }
            
            /*---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
            //      プリミティブセット削除用のドロップダウンを更新する
            /*---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
            function RemoveListRefresh(){
                if(array_remove.length == 0)
                array_remove[0] = "NULL";
                for(i = 0; i < panel_remove.children.length; i++){
                    if(panel_remove.children[i].type =="dropdownlist")
                    panel_remove.remove(i);
                    }
                
                dropdown_remove = panel_remove.add('dropdownlist', [23, 15, 23 + 80, 15 + 20], array_remove);
                dropdown_remove.items[0].selected = true;
                
                var remove_id = dropdown_remove.selection.text;
                var remove_index = 0;
                
                dropdown_remove.onChange = function(){ remove_id = dropdown_remove.selection.text; remove_index = dropdown_remove.selection.index; }
                RemovePrimitiveID = function(){ return [remove_id, remove_index]; }
                }
            
            /*---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
            //      選択されたレイヤーからスクリプトの適用が可能なレイヤーの配列と、タイムライン上で最上段、最下段のレイヤーが収納されている配列内の位置を返す
            //      レイヤーが選択されていなければnullを返す
            /*---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
            function CheckLayers(){
                var apply_nums = 0;
                var irregular = 0;      //選択されたレイヤーが全て同種ではなかった場合この変数に1以上が入る
                var cpa = 0;        //レイヤーのインデックス比較用
                var tl_first = 0        //適用可能レイヤーの最上段
                var tl_end = 0;     //適用可能レイヤーの最下段
                var targetArray = new Array();      //適用可能レイヤーを収納する配列
                
                var active = app.project.activeItem;
                if(active != null){
                    var selLayers = active.selectedLayers;
                    if(typeof selLayers != "Undefined" && selLayers.length != 0){
                        for(i = 0; i < selLayers.length; i++){
                            if((selLayers[i] instanceof AVLayer && selLayers[i].hasVideo) || selLayers[i] instanceof TextLayer || selLayers[i] instanceof LightLayer || selLayers[i] instanceof CameraLayer || selLayers[i] instanceof ShapeLayer){
                                targetArray[apply_nums] = selLayers[i];
                                apply_nums += 1;
                                }
                            }
                        
                        for(j = 1; j < targetArray.length; j++){
                            if(targetArray[j - 1].matchName != targetArray[j].matchName){
                                irregular += 1;
                                }
                            }
                        
                        if(irregular == 0){
                            for(k = 0; k < targetArray.length; k++){
                                if(cpa < targetArray[k].index){
                                    cpa = targetArray[k].index;
                                    tl_end = k;
                                    }
                                
                                else if(cpa > targetArray[k].index){
                                    cpa = targetArray[k].index;
                                    tl_first = k;
                                    }
                                }
                            return [targetArray, tl_first, tl_end];
                            }
                        else alert("2種以上のレイヤーが選択されています\n処理を中断します"); return null;
                        }
                    else return null;
                    }
                else return null;
                }
            
            /*---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
            //テキストをチェックする
            //半角数字のみの場合はテキストを整数に変換して返す
            //半角数字以外の文字が含まれていた場合はnullを返す
            /*---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
            function CheckText(checkText){
                var not_num = 0;
                for(i = 0; i < checkText.length; i++){
                    var numCharCode = checkText.charCodeAt(i);
                    if(numCharCode != 46 && numCharCode != 47 && numCharCode != 48 && numCharCode != 49 && numCharCode != 50 && numCharCode != 51 && numCharCode != 52 && numCharCode != 53 && numCharCode != 54 && numCharCode != 55 && numCharCode != 56 && numCharCode != 57){
                        var not_num = -1;
                        }
                    }
                
                if(not_num != -1 && !isNaN(parseFloat(checkText))){
                    return parseFloat(checkText);
                    }
                else return null;
                }
            
            /*---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
            //		レイヤーを複製する
            /*---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
            function DuplicateLayer(selLayer){
                var array_duplicate = new Array();
                var checkNum = CheckText (nums_duplicate.text);
                if(checkNum != null){
                    
                    app.beginUndoGroup(mp_text + "LayerDuplicate");
                    if(selLayer.length == 1){
                        for(i = 0; i < parseInt(checkNum); i++){
                            if(i == 0){
                                array_duplicate[i] = selLayer[0];
                                }
                            else{
                                array_duplicate[i] = selLayer[0].duplicate();
                                array_duplicate[i].selected = true;
                                }
                            }
                        
                        for(j = 0; j < array_duplicate.length; j++){
                            if(j != array_duplicate.length - 1){
                                array_duplicate[j].moveBefore(array_duplicate[array_duplicate.length - 1]);
                                }
                            }
                        
                        app.endUndoGroup();
                        }
                    else if(selLayer.length <= 0) alert("レイヤーを1枚選択してください")
                    else alert("2枚以上のレイヤーの同時に適用することは出来ません");
                    }
                else alert("半角数字を入力してください");
                }
            
        } else alert("非対応のバージョンです\nAfter Effects CS4以上でお使いください");
    }

/***********************************************************************************************/
//      UIチェック用の関数
/***********************************************************************************************/
function CheckUI(UIObject){
		var mainUI;
		if(UIObject instanceof Panel)
		mainUI = UIObject;
		else{
			mainUI = new Window('palette', "Make Primitive");
			mainUI.bounds = [0, 0, 0 + 253, 0 + 280];
			}
		return mainUI;
		}
